(** Very simple "high-level" profiler **)
open Unix
    
let time (s : string) (e : unit -> 'a) : 'a =
  let tstart = (Unix.times ()) in
  Printf.printf "ENTER: %s\n" s; 
  Pervasives.flush Pervasives.stdout;
  let a = e () in
  let tend = (Unix.times ()) in
  let tdelta = (tend.tms_utime -. tstart.tms_utime) +. (tend.tms_stime -. tstart.tms_stime) in
  (* Prints : #TIMER;<user string>;<time> *)
  Printf.printf "#TIMER,%s,%f\n" s tdelta;
  Pervasives.flush Pervasives.stdout;
  a

(* Does not print anything and returns the delta as well as the expression *)
let timer (e : unit -> 'a) : ('a * float) =
  let tstart = (Unix.times ()) in
  let a = e () in
  let tend = (Unix.times ()) in
  let tdelta = (tend.tms_utime -. tstart.tms_utime) +. (tend.tms_stime -. tstart.tms_stime) in
  (a, tdelta)
