open Datatypes
open BinPos
open BinInt

(* Functions related to comparisons and sorting *)

let cmp_pair_fst cmp = fun (p1, _) (p2, _) -> cmp p1 p2

let cmp_pair_same cmp = fun (p1, p2) (p3, p4) -> 
  let c = cmp p1 p3 in
  if c = 0 then cmp p2 p4 else c

let cmp_pos_asc : positive -> positive -> int = fun p1 p2 -> match coq_Pcompare p1 p2 Eq with | Lt -> -1 | Eq -> 0 | Gt -> 1
let cmp_pos_desc = fun p1 p2 -> match coq_Pcompare p1 p2 Eq with | Lt -> 1 | Eq -> 0 | Gt -> -1

let cmp_z_asc : coq_Z -> coq_Z -> int = fun z1 z2 -> match coq_Zcompare z1 z2 with | Lt -> -1 | Eq -> 0 | Gt -> 1
let cmp_z_desc = fun z1 z2 -> match coq_Zcompare z1 z2 with | Lt -> 1 | Eq -> 0 | Gt -> -1
